<template>
  <div class="white-block">
    <div class="padding">
      <h3>Личные данные</h3>
    </div>
    <hr/>
    <!--Фамилия Имя Отчество-->
    <div class="padding">
      <div class="row">
        <div class="columns four">
          <label for="lastName">Фамилия</label>
          <input
            type="text"
            name="lastName"
            v-model="$user.lastName"
            ref="lastName"
            id="lastName"
            v-validate="'cyrillic|required|min:2|max:50'"
            :class="getValidateClass('lastName')"
            autocomplete="off"
            data-code="lastNameTooShort, lastNameTooLong, lastNameInvalidFormat"
          />

          <validate-message v-show="vErrors.has('lastName')">
            {{ vErrors.first('lastName') }}
          </validate-message>

        </div>

        <div class="columns four">
          <label for="firstName">Имя</label>
          <input
            type="text"
            name="firstName"
            id="firstName"
            ref="firstName"
            v-validate="'cyrillic|required|min:2|max:50'"
            v-model="$user.firstName"
            :class="getValidateClass('firstName')"
            autocomplete="off"
            data-code="firstNameTooShort, firstNameTooLong, firstNameInvalidFormat"
          />

          <validate-message v-show="vErrors.has('firstName')">
            {{ vErrors.first('firstName') }}
          </validate-message>

        </div>

        <div class="columns four">
          <label for="middleName">Отчество</label>
          <input
            type="text"
            name="middleName"
            id="middleName"
            ref="middleName"
            v-validate="'required|cyrillic|min:2|max:50'"
            v-model="$user.middleName"
            :class="getValidateClass('middleName')"
            autocomplete="off"
            data-code="middleNameTooShort, middleNameTooLong, middleNameInvalidFormat"
          />

          <validate-message v-show="vErrors.has('middleName')">
            {{ vErrors.first('middleName') }}
          </validate-message>
        </div>

      </div>
    </div>
    <!--Дата рождения и место рождения-->
    <div class="padding">
      <div class="row">
        <div class="columns four">
          <label for="bDay">Дата рождения</label>

          <input
            type="tel"
            name="дата рождения"
            id="bDay"
            ref="bDay"
            v-validate="birthdayValidator"
            :class="getValidateClass('дата рождения')"
            v-model="$user.bDay"
            v-mask="'##.##.####'"
            :guide="true"
            placeholder="ДД.ММ.ГГГГ"
            :keepCharPositions="true"
            autocomplete="off"
            data-code="bDayInvalidDateFormat"
          >
          <validate-message v-show="vErrors.has('дата рождения')">
            {{ vErrors.first('дата рождения') }}
          </validate-message>

        </div>

        <div class="columns four">
          <label for="bPlace">Место рождения</label>
          <input type="text"
                 name="bPlace"
                 id="bPlace"
                 ref="bPlace"
                 v-model="$user.bPlace"
                 v-validate="'required|exceptLatinAndServiceChar|min:3'"
                 :class="getValidateClass('bPlace')"
                 data-code="bPlaceTooLong, bPlaceTooShort, bPlaceInvalidFormat"
          />
          <validate-message v-show="vErrors.has('bPlace')">
            {{ vErrors.first('bPlace') }}
          </validate-message>
        </div>

        <div class="columns four checkbox">
          <div class="label-profile" ref="gender">Пол</div>
          <input type="radio"
                 name="gender"
                 value="male"
                 id="male"
                 v-model="$user.gender"
                 v-validate="'required'"
                 @change="changeGenderOfUser"
                 data-code="genderNotInAvailableRange"
          />
          <label for="male"><span></span>Мужской</label>
          <input type="radio"
                 name="gender"
                 value="female"
                 id="female"
                 v-model="$user.gender"
                 v-validate="'required'"
                 :class="getValidateClass('female')"
                 data-code="genderNotInAvailableRange"
          />
          <label for="female"><span></span>Женский</label>
          <div class="checkbox-gender">
            <validate-message v-show="vErrors.has('gender')">
              {{ vErrors.first('gender') }}
            </validate-message>
          </div>
        </div>
      </div>
    </div>

  </div>
</template>

<script>
  import ErrorHandleMixin from '@/mixins/ErrorHandleMixin'
  import UserErrorText from '@/mixins/User/UserErrorTextMixin'
  import ChangeDataInProfile from '@/mixins/Profile/ChangeDataInProfile'
  import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin'
  import { REQUIRED_FIELD, MIN_LENGHT, MAX_LENGHT } from '@/components/Validators/CustomVeeValidateMessage'

  export default {
    mixins: [
      ErrorHandleMixin,
      UserErrorText,
      GetValidateClass,
      ChangeDataInProfile
    ],
    mounted () {
      this.$validator.localize(REQUIRED_FIELD)
      this.$validator.localize(MIN_LENGHT)
      this.$validator.localize(MAX_LENGHT)
    },
    data () {
      return {
        birthdayValidator: `required|date_format_check|date_between_bd`
      }
    }
  }
</script>

<style scoped lang="scss">
  .disabled {
    color: darkGray;
  }
</style>
